#include <iostream>
#include "Coda.h"
using namespace std;



void VisitaAlberoProfondita(Albero& a) {
	if (a == NULL)
		return;
	cout << a->info << '\t';
	VisitaAlberoProfondita(a->left);
	VisitaAlberoProfondita(a->right);
 }

void VisitaAlberoAmpiezza(Albero& a) {
	Coda c;
	InitCoda(c);
	NodoAlbero* nr = getRight(a);
	NodoAlbero* nl = getLeft(a);
	
	cout << endl;
	cout << a->info << '\t';;

	if (nr!=NULL)
		InsertCoda(c, *nr);
	if (nr!=NULL)
		InsertCoda(c, *nl);
		
	while (!EmptyCoda(c)) {
		NodoAlbero n;
		ExtractCoda(c, n);
		
		cout << n.info << '\t';
		
		NodoAlbero* nnr = getRight(&n);
		NodoAlbero* nnl = getLeft(&n);
		
		if (nnr!=NULL)
			InsertCoda(c, *nnr);
		if (nnl!=NULL)
			InsertCoda(c, *nnl);
	}
	
}

int main() {
	Albero a1;
	Albero a2;
	
	initAlbero(a1);
	createRoot(a1, 1);
	NodoAlbero* n1 = insert(a1,2);
	NodoAlbero* n2 = insert(a1,3);
	NodoAlbero* n3 = insert(n2,4);
	NodoAlbero* n4 = insert(n2,5);
	VisitaAlberoProfondita(a1);
	//VisitaAlberoAmpiezza(a);
	
	//NodoAlbero* nr = Right(n1);
	cout << endl;
    
   // system("pause");
   
   
	initAlbero(a2);
	createRoot(a2, 6);
	NodoAlbero* n5 = insert(a2,7);
	NodoAlbero* n6 = insert(a2,8);
	NodoAlbero* n7 = insert(n6,9);
	NodoAlbero* n8 = insert(n6,10);
	VisitaAlberoProfondita(a2);
	cout << endl;
	cout<< uguale(a1, a2)<<endl;
	
	return 0;
	
}
